---
title: Add Tenant Custom Nameserver
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Tenant Custom Nameservers](https://developers.cloudflare.com/api/go/resources/tenant_custom_nameservers)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Add Tenant Custom Nameserver

client.TenantCustomNameservers.New(ctx, tenantTag, body) (\*[TenantCustomNameserverNewResponse](<https://developers.cloudflare.com/api/go/resources/tenant_custom_nameservers#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)>), error)

POST/tenants/{tenant\_tag}/custom\_ns

Adds a custom nameserver for a tenant.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### ParametersExpand Collapse

tenantTag string

Tenant identifier tag.

maxLength32

[Link to this property](<#(resource)%20tenant_custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20tenant_tag%20%3E%20(schema)>)

<details>

<summary>

body TenantCustomNameserverNewParams

</summary>

NSName param.Field\[string]

The FQDN of the name server.

formathostname

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ns_name">Link to this property</a>

NSSet param.Field\[float64]Optional

The number of the set that this name server belongs to.

maximum5

minimum1

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20ns_set">Link to this property</a>

</details>

[Link to this property](<#(resource)%20tenant_custom_nameservers%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type TenantCustomNameserverNewResponse struct{…}

A single tenant custom nameserver.

</summary>

<details>

<summary>

DNSRecords \[]TenantCustomNameserverNewResponseDNSRecord

A and AAAA records associated with the nameserver.

</summary>

<details>

<summary>

Type TenantCustomNameserverNewResponseDNSRecordsTypeOptional

DNS record type.

</summary>

One of the following:

const TenantCustomNameserverNewResponseDNSRecordsTypeA TenantCustomNameserverNewResponseDNSRecordsType = "A"

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20type%20%3E%20(member)%200">Link to this property</a>

const TenantCustomNameserverNewResponseDNSRecordsTypeAAAA TenantCustomNameserverNewResponseDNSRecordsType = "AAAA"

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20type%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20type">Link to this property</a>

Value stringOptional

DNS record contents (an IPv4 or IPv6 address).

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20dns_records%20%3E%20(items)%20%3E%20(property)%20value">Link to this property</a>

</details>

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20dns_records">Link to this property</a>

NSName string

The FQDN of the name server.

formathostname

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20ns_name">Link to this property</a>

<details>

<summary>

DeprecatedStatus TenantCustomNameserverNewResponseStatus

Verification status of the nameserver.

</summary>

One of the following:

const TenantCustomNameserverNewResponseStatusMoved TenantCustomNameserverNewResponseStatus = "moved"

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

const TenantCustomNameserverNewResponseStatusPending TenantCustomNameserverNewResponseStatus = "pending"

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

const TenantCustomNameserverNewResponseStatusVerified TenantCustomNameserverNewResponseStatus = "verified"

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%202">Link to this property</a>

</details>

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20status">Link to this property</a>

ZoneTag string

Identifier.

maxLength32

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20zone_tag">Link to this property</a>

NSSet float64Optional

The number of the set that this name server belongs to.

maximum5

minimum1

<a href="#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)%20%3E%20(property)%20ns_set">Link to this property</a>

</details>

[Link to this property](<#(resource)%20tenant_custom_nameservers%20%3E%20(model)%20TenantCustomNameserverNewResponse%20%3E%20(schema)>)

### Add Tenant Custom Nameserver

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/tenant_custom_nameservers"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  tenantCustomNameserver, err := client.TenantCustomNameservers.New(
    context.TODO(),
    "699d98642c564d2e855e9661899b7252",
    tenant_custom_nameservers.TenantCustomNameserverNewParams{
      NSName: cloudflare.F("ns1.example.com"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", tenantCustomNameserver.DNSRecords)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "dns_records": [
      {
        "type": "A",
        "value": "1.1.1.1"
      }
    ],
    "ns_name": "ns1.example.com",
    "status": "verified",
    "zone_tag": "023e105f4ecef8ad9ca31a8372d0c353",
    "ns_set": 1
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "dns_records": [
      {
        "type": "A",
        "value": "1.1.1.1"
      }
    ],
    "ns_name": "ns1.example.com",
    "status": "verified",
    "zone_tag": "023e105f4ecef8ad9ca31a8372d0c353",
    "ns_set": 1
  }
}
```